; ======================================================================================================================
; Type        : Wrapper 
; Projet      : HARU free PDF : libharu.sourceforge.net
; Historique  : 
;   0.1       : Premire version du code par 'Alloun hichem' alias fraalg
; 
; ======================================================================================================================

;{ Constantes
  #HPDF_TRUE         =       1
  #HPDF_FALSE        =       0
  #HPDF_OK           =       0
  #HPDF_NOERROR      =       0
  #HPDF_TMP_BUF_SIZ        =    512
  #HPDF_SHORT_BUF_SIZ      =    32
  #HPDF_REAL_LEN           =    11
  #HPDF_INT_LEN            =    11
  #HPDF_TEXT_DEFAULT_LEN   =    256
  #HPDF_UNICODE_HEADER_LEN =    2
  #HPDF_DATE_TIME_STR_LEN  =    23
  #HPDF_BYTE_OFFSET_LEN    =    10
  #HPDF_OBJ_ID_LEN         =    7
  #HPDF_GEN_NO_LEN         =    5
  #HPDF_DEF_FONT           =    "Helvetica"
  #HPDF_DEF_PAGE_LAYOUT    =    0;HPDF_PAGE_LAYOUT_SINGLE
  #HPDF_DEF_PAGE_MODE      =    0;HPDF_PAGE_MODE_USE_NONE
  #HPDF_DEF_WORDSPACE      =    0
  #HPDF_DEF_CHARSPACE      =    0
  #HPDF_DEF_FONTSIZE       =    10
  #HPDF_DEF_HSCALING       =    100
  #HPDF_DEF_LEADING        =    0
  #HPDF_DEF_RENDERING_MODE =    0;HPDF_FILL
  #HPDF_DEF_RISE           =    0
  #HPDF_DEF_RAISE          =    0;HPDF_DEF_RISE
  #HPDF_DEF_LINEWIDTH      =    1
  #HPDF_DEF_LINECAP        =    0;HPDF_BUTT_END
  #HPDF_DEF_LINEJOIN       =    0;HPDF_MITER_JOIN
  #HPDF_DEF_MITERLIMIT     =    10
  #HPDF_DEF_FLATNESS       =    1
  #HPDF_DEF_PAGE_NUM       =    1
  
  #HPDF_BS_DEF_WIDTH       =    1
  #HPDF_DEF_PAGE_WIDTH     =    595.276
  #HPDF_DEF_PAGE_HEIGHT    =    841.89
  
  #HPDF_VERSION_TEXT       =    "2.0.8"
  
  #HPDF_COMP_NONE      =      0
  #HPDF_COMP_TEXT      =      1
  #HPDF_COMP_IMAGE     =      2
  #HPDF_COMP_METADATA  =      4
  #HPDF_COMP_ALL       =      15
  
  #HPDF_COMP_MASK      =      255
  
  #HPDF_ENABLE_READ     =    0
  #HPDF_ENABLE_PRINT    =    4
  #HPDF_ENABLE_EDIT_ALL =    8
  #HPDF_ENABLE_COPY     =    16
  #HPDF_ENABLE_EDIT     =    32
  
  #HPDF_HIDE_TOOLBAR   = 1
  #HPDF_HIDE_MENUBAR   = 2
  #HPDF_HIDE_WINDOW_UI = 4
  #HPDF_FIT_WINDOW     = 8
  #HPDF_CENTER_WINDOW  = 16
  
  #HPDF_LIMIT_MAX_INT       =      2147483647
  #HPDF_LIMIT_MIN_INT       =      -2147483647
  
  #HPDF_LIMIT_MAX_REAL       =     32767
  #HPDF_LIMIT_MIN_REAL       =     -32767
  
  #HPDF_LIMIT_MAX_STRING_LEN  =    65535
  #HPDF_LIMIT_MAX_NAME_LEN    =    127
  
  #HPDF_LIMIT_MAX_ARRAY         =  8191
  #HPDF_LIMIT_MAX_DICT_ELEMENT  =  4095
  #HPDF_LIMIT_MAX_XREF_ELEMENT  =  8388607
  #HPDF_LIMIT_MAX_GSTATE        =  28
  #HPDF_LIMIT_MAX_DEVICE_N      =  8
  #HPDF_LIMIT_MAX_DEVICE_N_V15  =  32
  #HPDF_LIMIT_MAX_CID           =  65535
  #HPDF_MAX_GENERATION_NUM      =  65535
  
  #HPDF_MIN_PAGE_HEIGHT          =  3
  #HPDF_MIN_PAGE_WIDTH           =  3
  #HPDF_MAX_PAGE_HEIGHT          = 14400
  #HPDF_MAX_PAGE_WIDTH           = 14400
  #HPDF_MIN_MAGNIFICATION_FACTOR = 8
  #HPDF_MAX_MAGNIFICATION_FACTOR = 3200
  
  #HPDF_MIN_PAGE_SIZE         = 3
  #HPDF_MAX_PAGE_SIZE         = 14400
  #HPDF_MIN_HORIZONTALSCALING = 10
  #HPDF_MAX_HORIZONTALSCALING = 300
  #HPDF_MIN_WORDSPACE         = -30
  #HPDF_MAX_WORDSPACE         = 300
  #HPDF_MIN_CHARSPACE         = -30
  #HPDF_MAX_CHARSPACE         = 300
  #HPDF_MAX_FONTSIZE          = 300
  #HPDF_MAX_ZOOMSIZE          = 10
  #HPDF_MAX_LEADING           = 300
  #HPDF_MAX_LINEWIDTH         = 100
  #HPDF_MAX_DASH_PATTERN      = 100
  
  #HPDF_MAX_JWW_NUM           = 128
  
  ;{ Country
  #HPDF_COUNTRY_AF = "AF"    ; AFGHANISTAN 
  #HPDF_COUNTRY_AL = "AL"    ; ALBANIA 
  #HPDF_COUNTRY_DZ = "DZ"    ; ALGERIA 
  #HPDF_COUNTRY_AS = "AS"    ; AMERICAN SAMOA 
  #HPDF_COUNTRY_AD = "AD"    ; ANDORRA 
  #HPDF_COUNTRY_AO = "AO"    ; ANGOLA 
  #HPDF_COUNTRY_AI = "AI"    ; ANGUILLA 
  #HPDF_COUNTRY_AQ = "AQ"    ; ANTARCTICA 
  #HPDF_COUNTRY_AG = "AG"    ; ANTIGUA And BARBUDA 
  #HPDF_COUNTRY_AR = "AR"    ; ARGENTINA 
  #HPDF_COUNTRY_AM = "AM"    ; ARMENIA 
  #HPDF_COUNTRY_AW = "AW"    ; ARUBA 
  #HPDF_COUNTRY_AU = "AU"    ; AUSTRALIA 
  #HPDF_COUNTRY_AT = "AT"    ; AUSTRIA 
  #HPDF_COUNTRY_AZ = "AZ"    ; AZERBAIJAN 
  #HPDF_COUNTRY_BS = "BS"    ; BAHAMAS 
  #HPDF_COUNTRY_BH = "BH"    ; BAHRAIN 
  #HPDF_COUNTRY_BD = "BD"    ; BANGLADESH 
  #HPDF_COUNTRY_BB = "BB"    ; BARBADOS 
  #HPDF_COUNTRY_BY = "BY"    ; BELARUS 
  #HPDF_COUNTRY_BE = "BE"    ; BELGIUM 
  #HPDF_COUNTRY_BZ = "BZ"    ; BELIZE 
  #HPDF_COUNTRY_BJ = "BJ"    ; BENIN 
  #HPDF_COUNTRY_BM = "BM"    ; BERMUDA 
  #HPDF_COUNTRY_BT = "BT"    ; BHUTAN 
  #HPDF_COUNTRY_BO = "BO"    ; BOLIVIA 
  #HPDF_COUNTRY_BA = "BA"    ; BOSNIA And HERZEGOWINA 
  #HPDF_COUNTRY_BW = "BW"    ; BOTSWANA 
  #HPDF_COUNTRY_BV = "BV"    ; BOUVET ISLAND 
  #HPDF_COUNTRY_BR = "BR"    ; BRAZIL 
  #HPDF_COUNTRY_IO = "IO"    ; BRITISH INDIAN OCEAN TERRITORY 
  #HPDF_COUNTRY_BN = "BN"    ; BRUNEI DARUSSALAM 
  #HPDF_COUNTRY_BG = "BG"    ; BULGARIA 
  #HPDF_COUNTRY_BF = "BF"    ; BURKINA FASO 
  #HPDF_COUNTRY_BI = "BI"    ; BURUNDI 
  #HPDF_COUNTRY_KH = "KH"    ; CAMBODIA 
  #HPDF_COUNTRY_CM = "CM"    ; CAMEROON 
  #HPDF_COUNTRY_CA = "CA"    ; CANADA 
  #HPDF_COUNTRY_CV = "CV"    ; CAPE VERDE 
  #HPDF_COUNTRY_KY = "KY"    ; CAYMAN ISLANDS 
  #HPDF_COUNTRY_CF = "CF"    ; CENTRAL AFRICAN REPUBLIC 
  #HPDF_COUNTRY_TD = "TD"    ; CHAD 
  #HPDF_COUNTRY_CL = "CL"    ; CHILE 
  #HPDF_COUNTRY_CN = "CN"    ; CHINA 
  #HPDF_COUNTRY_CX = "CX"    ; CHRISTMAS ISLAND 
  #HPDF_COUNTRY_CC = "CC"    ; COCOS (KEELING) ISLANDS 
  #HPDF_COUNTRY_CO = "CO"    ; COLOMBIA 
  #HPDF_COUNTRY_KM = "KM"    ; COMOROS 
  #HPDF_COUNTRY_CG = "CG"    ; CONGO 
  #HPDF_COUNTRY_CK = "CK"    ; COOK ISLANDS 
  #HPDF_COUNTRY_CR = "CR"    ; COSTA RICA 
  #HPDF_COUNTRY_CI = "CI"    ; COTE D'IVOIRE 
  #HPDF_COUNTRY_HR = "HR"    ; CROATIA (local name: Hrvatska) 
  #HPDF_COUNTRY_CU = "CU"    ; CUBA 
  #HPDF_COUNTRY_CY = "CY"    ; CYPRUS 
  #HPDF_COUNTRY_CZ = "CZ"    ; CZECH REPUBLIC 
  #HPDF_COUNTRY_DK = "DK"    ; DENMARK 
  #HPDF_COUNTRY_DJ = "DJ"    ; DJIBOUTI 
  #HPDF_COUNTRY_DM = "DM"    ; DOMINICA 
  #HPDF_COUNTRY_DO = "DO"    ; DOMINICAN REPUBLIC 
  #HPDF_COUNTRY_TP = "TP"    ; EAST TIMOR 
  #HPDF_COUNTRY_EC = "EC"    ; ECUADOR 
  #HPDF_COUNTRY_EG = "EG"    ; EGYPT 
  #HPDF_COUNTRY_SV = "SV"    ; EL SALVADOR 
  #HPDF_COUNTRY_GQ = "GQ"    ; EQUATORIAL GUINEA 
  #HPDF_COUNTRY_ER = "ER"    ; ERITREA 
  #HPDF_COUNTRY_EE = "EE"    ; ESTONIA 
  #HPDF_COUNTRY_ET = "ET"    ; ETHIOPIA 
  #HPDF_COUNTRY_FK = "FK"    ; FALKLAND ISLANDS (MALVINAS) 
  #HPDF_COUNTRY_FO = "FO"    ; FAROE ISLANDS 
  #HPDF_COUNTRY_FJ = "FJ"    ; FIJI 
  #HPDF_COUNTRY_FI = "FI"    ; FINLAND 
  #HPDF_COUNTRY_FR = "FR"    ; FRANCE 
  #HPDF_COUNTRY_FX = "FX"    ; FRANCE, METROPOLITAN 
  #HPDF_COUNTRY_GF = "GF"    ; FRENCH GUIANA 
  #HPDF_COUNTRY_PF = "PF"    ; FRENCH POLYNESIA 
  #HPDF_COUNTRY_TF = "TF"    ; FRENCH SOUTHERN TERRITORIES 
  #HPDF_COUNTRY_GA = "GA"    ; GABON 
  #HPDF_COUNTRY_GM = "GM"    ; GAMBIA 
  #HPDF_COUNTRY_GE = "GE"    ; GEORGIA 
  #HPDF_COUNTRY_DE = "DE"    ; GERMANY 
  #HPDF_COUNTRY_GH = "GH"    ; GHANA 
  #HPDF_COUNTRY_GI = "GI"    ; GIBRALTAR 
  #HPDF_COUNTRY_GR = "GR"    ; GREECE 
  #HPDF_COUNTRY_GL = "GL"    ; GREENLAND 
  #HPDF_COUNTRY_GD = "GD"    ; GRENADA 
  #HPDF_COUNTRY_GP = "GP"    ; GUADELOUPE 
  #HPDF_COUNTRY_GU = "GU"    ; GUAM 
  #HPDF_COUNTRY_GT = "GT"    ; GUATEMALA 
  #HPDF_COUNTRY_GN = "GN"    ; GUINEA 
  #HPDF_COUNTRY_GW = "GW"    ; GUINEA-BISSAU 
  #HPDF_COUNTRY_GY = "GY"    ; GUYANA 
  #HPDF_COUNTRY_HT = "HT"    ; HAITI 
  #HPDF_COUNTRY_HM = "HM"    ; HEARD And MC DONALD ISLANDS 
  #HPDF_COUNTRY_HN = "HN"    ; HONDURAS 
  #HPDF_COUNTRY_HK = "HK"    ; HONG KONG 
  #HPDF_COUNTRY_HU = "HU"    ; HUNGARY 
  #HPDF_COUNTRY_IS = "IS"    ; ICELAND 
  #HPDF_COUNTRY_IN = "IN"    ; INDIA 
  #HPDF_COUNTRY_ID = "ID"    ; INDONESIA 
  #HPDF_COUNTRY_IR = "IR"    ; IRAN (ISLAMIC REPUBLIC OF) 
  #HPDF_COUNTRY_IQ = "IQ"    ; IRAQ 
  #HPDF_COUNTRY_IE = "IE"    ; IRELAND 
  #HPDF_COUNTRY_IL = "IL"    ; ISRAEL 
  #HPDF_COUNTRY_IT = "IT"    ; ITALY 
  #HPDF_COUNTRY_JM = "JM"    ; JAMAICA 
  #HPDF_COUNTRY_JP = "JP"    ; JAPAN 
  #HPDF_COUNTRY_JO = "JO"    ; JORDAN 
  #HPDF_COUNTRY_KZ = "KZ"    ; KAZAKHSTAN 
  #HPDF_COUNTRY_KE = "KE"    ; KENYA 
  #HPDF_COUNTRY_KI = "KI"    ; KIRIBATI 
  #HPDF_COUNTRY_KP = "KP"    ; KOREA, DEMOCRATIC PEOPLE'S REPUBLIC OF 
  #HPDF_COUNTRY_KR = "KR"    ; KOREA, REPUBLIC OF 
  #HPDF_COUNTRY_KW = "KW"    ; KUWAIT 
  #HPDF_COUNTRY_KG = "KG"    ; KYRGYZSTAN 
  #HPDF_COUNTRY_LA = "LA"    ; LAO PEOPLE'S DEMOCRATIC REPUBLIC 
  #HPDF_COUNTRY_LV = "LV"    ; LATVIA 
  #HPDF_COUNTRY_LB = "LB"    ; LEBANON 
  #HPDF_COUNTRY_LS = "LS"    ; LESOTHO 
  #HPDF_COUNTRY_LR = "LR"    ; LIBERIA 
  #HPDF_COUNTRY_LY = "LY"    ; LIBYAN ARAB JAMAHIRIYA 
  #HPDF_COUNTRY_LI = "LI"    ; LIECHTENSTEIN 
  #HPDF_COUNTRY_LT = "LT"    ; LITHUANIA 
  #HPDF_COUNTRY_LU = "LU"    ; LUXEMBOURG 
  #HPDF_COUNTRY_MO = "MO"    ; MACAU 
  #HPDF_COUNTRY_MK = "MK"   ; MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF 
  #HPDF_COUNTRY_MG = "MG"    ; MADAGASCAR 
  #HPDF_COUNTRY_MW = "MW"    ; MALAWI 
  #HPDF_COUNTRY_MY = "MY"    ; MALAYSIA 
  #HPDF_COUNTRY_MV = "MV"    ; MALDIVES 
  #HPDF_COUNTRY_ML = "ML"    ; MALI 
  #HPDF_COUNTRY_MT = "MT"    ; MALTA 
  #HPDF_COUNTRY_MH = "MH"    ; MARSHALL ISLANDS 
  #HPDF_COUNTRY_MQ = "MQ"    ; MARTINIQUE 
  #HPDF_COUNTRY_MR = "MR"    ; MAURITANIA 
  #HPDF_COUNTRY_MU = "MU"    ; MAURITIUS 
  #HPDF_COUNTRY_YT = "YT"    ; MAYOTTE 
  #HPDF_COUNTRY_MX = "MX"    ; MEXICO 
  #HPDF_COUNTRY_FM = "FM"    ; MICRONESIA, FEDERATED STATES OF 
  #HPDF_COUNTRY_MD = "MD"    ; MOLDOVA, REPUBLIC OF 
  #HPDF_COUNTRY_MC = "MC"    ; MONACO 
  #HPDF_COUNTRY_MN = "MN"    ; MONGOLIA 
  #HPDF_COUNTRY_MS = "MS"    ; MONTSERRAT 
  #HPDF_COUNTRY_MA = "MA"    ; MOROCCO 
  #HPDF_COUNTRY_MZ = "MZ"    ; MOZAMBIQUE 
  #HPDF_COUNTRY_MM = "MM"    ; MYANMAR 
  #HPDF_COUNTRY_NA = "NA"    ; NAMIBIA 
  #HPDF_COUNTRY_NR = "NR"    ; NAURU 
  #HPDF_COUNTRY_NP = "NP"    ; NEPAL 
  #HPDF_COUNTRY_NL = "NL"    ; NETHERLANDS 
  #HPDF_COUNTRY_AN = "AN"    ; NETHERLANDS ANTILLES 
  #HPDF_COUNTRY_NC = "NC"    ; NEW CALEDONIA 
  #HPDF_COUNTRY_NZ = "NZ"    ; NEW ZEALAND 
  #HPDF_COUNTRY_NI = "NI"    ; NICARAGUA 
  #HPDF_COUNTRY_NE = "NE"    ; NIGER 
  #HPDF_COUNTRY_NG = "NG"    ; NIGERIA 
  #HPDF_COUNTRY_NU = "NU"    ; NIUE 
  #HPDF_COUNTRY_NF = "NF"    ; NORFOLK ISLAND 
  #HPDF_COUNTRY_MP = "MP"    ; NORTHERN MARIANA ISLANDS 
  #HPDF_COUNTRY_NO = "NO"    ; NORWAY 
  #HPDF_COUNTRY_OM = "OM"    ; OMAN 
  #HPDF_COUNTRY_PK = "PK"    ; PAKISTAN 
  #HPDF_COUNTRY_PW = "PW"    ; PALAU 
  #HPDF_COUNTRY_PA = "PA"    ; PANAMA 
  #HPDF_COUNTRY_PG = "PG"    ; PAPUA NEW GUINEA 
  #HPDF_COUNTRY_PY = "PY"    ; PARAGUAY 
  #HPDF_COUNTRY_PE = "PE"    ; PERU 
  #HPDF_COUNTRY_PH = "PH"    ; PHILIPPINES 
  #HPDF_COUNTRY_PN = "PN"    ; PITCAIRN 
  #HPDF_COUNTRY_PL = "PL"    ; POLAND 
  #HPDF_COUNTRY_PT = "PT"    ; PORTUGAL 
  #HPDF_COUNTRY_PR = "PR"    ; PUERTO RICO 
  #HPDF_COUNTRY_QA = "QA"    ; QATAR 
  #HPDF_COUNTRY_RE = "RE"    ; REUNION 
  #HPDF_COUNTRY_RO = "RO"    ; ROMANIA 
  #HPDF_COUNTRY_RU = "RU"    ; RUSSIAN FEDERATION 
  #HPDF_COUNTRY_RW = "RW"    ; RWANDA 
  #HPDF_COUNTRY_KN = "KN"    ; SAINT KITTS And NEVIS 
  #HPDF_COUNTRY_LC = "LC"    ; SAINT LUCIA 
  #HPDF_COUNTRY_VC = "VC"    ; SAINT VINCENT And THE GRENADINES 
  #HPDF_COUNTRY_WS = "WS"    ; SAMOA 
  #HPDF_COUNTRY_SM = "SM"    ; SAN MARINO 
  #HPDF_COUNTRY_ST = "ST"    ; SAO TOME And PRINCIPE 
  #HPDF_COUNTRY_SA = "SA"    ; SAUDI ARABIA 
  #HPDF_COUNTRY_SN = "SN"    ; SENEGAL 
  #HPDF_COUNTRY_SC = "SC"    ; SEYCHELLES 
  #HPDF_COUNTRY_SL = "SL"    ; SIERRA LEONE 
  #HPDF_COUNTRY_SG = "SG"    ; SINGAPORE 
  #HPDF_COUNTRY_SK = "SK"    ; SLOVAKIA (Slovak Republic) 
  #HPDF_COUNTRY_SI = "SI"    ; SLOVENIA 
  #HPDF_COUNTRY_SB = "SB"    ; SOLOMON ISLANDS 
  #HPDF_COUNTRY_SO = "SO"    ; SOMALIA 
  #HPDF_COUNTRY_ZA = "ZA"    ; SOUTH AFRICA 
  #HPDF_COUNTRY_ES = "ES"    ; SPAIN 
  #HPDF_COUNTRY_LK = "LK"    ; SRI LANKA 
  #HPDF_COUNTRY_SH = "SH"    ; ST. HELENA 
  #HPDF_COUNTRY_PM = "PM"    ; ST. PIERRE And MIQUELON 
  #HPDF_COUNTRY_SD = "SD"    ; SUDAN 
  #HPDF_COUNTRY_SR = "SR"    ; SURINAME 
  #HPDF_COUNTRY_SJ = "SJ"    ; SVALBARD And JAN MAYEN ISLANDS 
  #HPDF_COUNTRY_SZ = "SZ"    ; SWAZILAND 
  #HPDF_COUNTRY_SE = "SE"    ; SWEDEN 
  #HPDF_COUNTRY_CH = "CH"    ; SWITZERLAND 
  #HPDF_COUNTRY_SY = "SY"    ; SYRIAN ARAB REPUBLIC 
  #HPDF_COUNTRY_TW = "TW"    ; TAIWAN, PROVINCE OF CHINA 
  #HPDF_COUNTRY_TJ = "TJ"    ; TAJIKISTAN 
  #HPDF_COUNTRY_TZ = "TZ"    ; TANZANIA, UNITED REPUBLIC OF 
  #HPDF_COUNTRY_TH = "TH"    ; THAILAND 
  #HPDF_COUNTRY_TG = "TG"    ; TOGO 
  #HPDF_COUNTRY_TK = "TK"    ; TOKELAU 
  #HPDF_COUNTRY_TO = "TO"    ; TONGA 
  #HPDF_COUNTRY_TT = "TT"    ; TRINIDAD And TOBAGO 
  #HPDF_COUNTRY_TN = "TN"    ; TUNISIA 
  #HPDF_COUNTRY_TR = "TR"    ; TURKEY 
  #HPDF_COUNTRY_TM = "TM"    ; TURKMENISTAN 
  #HPDF_COUNTRY_TC = "TC"    ; TURKS And CAICOS ISLANDS 
  #HPDF_COUNTRY_TV = "TV"    ; TUVALU 
  #HPDF_COUNTRY_UG = "UG"    ; UGANDA 
  #HPDF_COUNTRY_UA = "UA"    ; UKRAINE 
  #HPDF_COUNTRY_AE = "AE"    ; UNITED ARAB EMIRATES 
  #HPDF_COUNTRY_GB = "GB"    ; UNITED KINGDOM 
  #HPDF_COUNTRY_US = "US"    ; UNITED STATES 
  #HPDF_COUNTRY_UM = "UM"    ; UNITED STATES MINOR OUTLYING ISLANDS 
  #HPDF_COUNTRY_UY = "UY"    ; URUGUAY 
  #HPDF_COUNTRY_UZ = "UZ"    ; UZBEKISTAN 
  #HPDF_COUNTRY_VU = "VU"    ; VANUATU 
  #HPDF_COUNTRY_VA = "VA"    ; VATICAN CITY STATE (HOLY SEE) 
  #HPDF_COUNTRY_VE = "VE"    ; VENEZUELA 
  #HPDF_COUNTRY_VN = "VN"    ; VIET NAM 
  #HPDF_COUNTRY_VG = "VG"    ; VIRGIN ISLANDS (BRITISH) 
  #HPDF_COUNTRY_VI = "VI"    ; VIRGIN ISLANDS (U.S.) 
  #HPDF_COUNTRY_WF = "WF"    ; WALLIS And FUTUNA ISLANDS 
  #HPDF_COUNTRY_EH = "EH"    ; WESTERN SAHARA 
  #HPDF_COUNTRY_YE = "YE"    ; YEMEN 
  #HPDF_COUNTRY_YU = "YU"    ; YUGOSLAVIA 
  #HPDF_COUNTRY_ZR = "ZR"    ; ZAIRE 
  #HPDF_COUNTRY_ZM = "ZM"    ; ZAMBIA 
  #HPDF_COUNTRY_ZW = "ZW"    ; ZIMBABWE 
  ;}
  ;{ Lang
  #HPDF_LANG_AA  =  "aa"     ; Afar 
  #HPDF_LANG_AB  =  "ab"     ; Abkhazian 
  #HPDF_LANG_AF  =  "af"     ; Afrikaans 
  #HPDF_LANG_AM  =  "am"     ; Amharic 
  #HPDF_LANG_AR  =  "ar"     ; Arabic 
  #HPDF_LANG_AS  =  "as"     ; Assamese 
  #HPDF_LANG_AY  =  "ay"     ; Aymara 
  #HPDF_LANG_AZ  =  "az"     ; Azerbaijani 
  #HPDF_LANG_BA  =  "ba"     ; Bashkir 
  #HPDF_LANG_BE  =  "be"     ; Byelorussian 
  #HPDF_LANG_BG  =  "bg"     ; Bulgarian 
  #HPDF_LANG_BH  =  "bh"     ; Bihari 
  #HPDF_LANG_BI  =  "bi"     ; Bislama 
  #HPDF_LANG_BN  =  "bn"     ; Bengali Bangla 
  #HPDF_LANG_BO  =  "bo"     ; Tibetan 
  #HPDF_LANG_BR  =  "br"     ; Breton 
  #HPDF_LANG_CA  =  "ca"     ; Catalan 
  #HPDF_LANG_CO  =  "co"     ; Corsican 
  #HPDF_LANG_CS  =  "cs"     ; Czech 
  #HPDF_LANG_CY  =  "cy"     ; Welsh 
  #HPDF_LANG_DA  =  "da"     ; Danish 
  #HPDF_LANG_DE  =  "de"     ; German 
  #HPDF_LANG_DZ  =  "dz"     ; Bhutani 
  #HPDF_LANG_EL  =  "el"     ; Greek 
  #HPDF_LANG_EN  =  "en"     ; English 
  #HPDF_LANG_EO  =  "eo"     ; Esperanto 
  #HPDF_LANG_ES  =  "es"     ; Spanish 
  #HPDF_LANG_ET  =  "et"     ; Estonian 
  #HPDF_LANG_EU  =  "eu"     ; Basque 
  #HPDF_LANG_FA  =  "fa"     ; Persian 
  #HPDF_LANG_FI  =  "fi"     ; Finnish 
  #HPDF_LANG_FJ  =  "fj"     ; Fiji 
  #HPDF_LANG_FO  =  "fo"     ; Faeroese 
  #HPDF_LANG_FR  =  "fr"     ; French 
  #HPDF_LANG_FY  =  "fy"     ; Frisian 
  #HPDF_LANG_GA  =  "ga"     ; Irish 
  #HPDF_LANG_GD  =  "gd"     ; Scots Gaelic 
  #HPDF_LANG_GL  =  "gl"     ; Galician 
  #HPDF_LANG_GN  =  "gn"     ; Guarani 
  #HPDF_LANG_GU  =  "gu"     ; Gujarati 
  #HPDF_LANG_HA  =  "ha"     ; Hausa 
  #HPDF_LANG_HI  =  "hi"     ; Hindi 
  #HPDF_LANG_HR  =  "hr"     ; Croatian 
  #HPDF_LANG_HU  =  "hu"     ; Hungarian 
  #HPDF_LANG_HY  =  "hy"     ; Armenian 
  #HPDF_LANG_IA  =  "ia"     ; Interlingua 
  #HPDF_LANG_IE  =  "ie"     ; Interlingue 
  #HPDF_LANG_IK  =  "ik"     ; Inupiak 
  #HPDF_LANG_IN  =  "in"     ; Indonesian 
  #HPDF_LANG_IS  =  "is"     ; Icelandic 
  #HPDF_LANG_IT  =  "it"     ; Italian 
  #HPDF_LANG_IW  =  "iw"     ; Hebrew 
  #HPDF_LANG_JA  =  "ja"     ; Japanese 
  #HPDF_LANG_JI  =  "ji"     ; Yiddish 
  #HPDF_LANG_JW  =  "jw"     ; Javanese 
  #HPDF_LANG_KA  =  "ka"     ; Georgian 
  #HPDF_LANG_KK  =  "kk"     ; Kazakh 
  #HPDF_LANG_KL  =  "kl"     ; Greenlandic 
  #HPDF_LANG_KM  =  "km"     ; Cambodian 
  #HPDF_LANG_KN  =  "kn"     ; Kannada 
  #HPDF_LANG_KO  =  "ko"     ; Korean 
  #HPDF_LANG_KS  =  "ks"     ; Kashmiri 
  #HPDF_LANG_KU  =  "ku"     ; Kurdish 
  #HPDF_LANG_KY  =  "ky"     ; Kirghiz 
  #HPDF_LANG_LA  =  "la"     ; Latin 
  #HPDF_LANG_LN  =  "ln"     ; Lingala 
  #HPDF_LANG_LO  =  "lo"     ; Laothian 
  #HPDF_LANG_LT  =  "lt"     ; Lithuanian 
  #HPDF_LANG_LV  =  "lv"     ; Latvian,Lettish 
  #HPDF_LANG_MG  =  "mg"     ; Malagasy 
  #HPDF_LANG_MI  =  "mi"     ; Maori 
  #HPDF_LANG_MK  =  "mk"     ; Macedonian 
  #HPDF_LANG_ML  =  "ml"     ; Malayalam 
  #HPDF_LANG_MN  =  "mn"     ; Mongolian 
  #HPDF_LANG_MO  =  "mo"     ; Moldavian 
  #HPDF_LANG_MR  =  "mr"     ; Marathi 
  #HPDF_LANG_MS  =  "ms"     ; Malay 
  #HPDF_LANG_MT  =  "mt"     ; Maltese 
  #HPDF_LANG_MY  =  "my"     ; Burmese 
  #HPDF_LANG_NA  =  "na"     ; Nauru 
  #HPDF_LANG_NE  =  "ne"     ; Nepali 
  #HPDF_LANG_NL  =  "nl"     ; Dutch 
  #HPDF_LANG_NO  =  "no"     ; Norwegian 
  #HPDF_LANG_OC  =  "oc"     ; Occitan 
  #HPDF_LANG_OM  =  "om"     ; (Afan)Oromo 
  #HPDF_LANG_OR  =  "or"     ; Oriya 
  #HPDF_LANG_PA  =  "pa"     ; Punjabi 
  #HPDF_LANG_PL  =  "pl"     ; Polish 
  #HPDF_LANG_PS  =  "ps"     ; Pashto,Pushto 
  #HPDF_LANG_PT  =  "pt"     ; Portuguese  
  #HPDF_LANG_QU  =  "qu"     ; Quechua 
  #HPDF_LANG_RM  =  "rm"     ; Rhaeto-Romance 
  #HPDF_LANG_RN  =  "rn"     ; Kirundi 
  #HPDF_LANG_RO  =  "ro"     ; Romanian 
  #HPDF_LANG_RU  =  "ru"     ; Russian 
  #HPDF_LANG_RW  =  "rw"     ; Kinyarwanda 
  #HPDF_LANG_SA  =  "sa"     ; Sanskrit 
  #HPDF_LANG_SD  =  "sd"     ; Sindhi 
  #HPDF_LANG_SG  =  "sg"     ; Sangro 
  #HPDF_LANG_SH  =  "sh"     ; Serbo-Croatian 
  #HPDF_LANG_SI  =  "si"     ; Singhalese 
  #HPDF_LANG_SK  =  "sk"     ; Slovak 
  #HPDF_LANG_SL  =  "sl"     ; Slovenian 
  #HPDF_LANG_SM  =  "sm"     ; Samoan 
  #HPDF_LANG_SN  =  "sn"     ; Shona 
  #HPDF_LANG_SO  =  "so"     ; Somali 
  #HPDF_LANG_SQ  =  "sq"     ; Albanian 
  #HPDF_LANG_SR  =  "sr"     ; Serbian 
  #HPDF_LANG_SS  =  "ss"     ; Siswati 
  #HPDF_LANG_ST  =  "st"     ; Sesotho 
  #HPDF_LANG_SU  =  "su"     ; Sundanese 
  #HPDF_LANG_SV  =  "sv"     ; Swedish 
  #HPDF_LANG_SW  =  "sw"     ; Swahili 
  #HPDF_LANG_TA  =  "ta"     ; Tamil 
  #HPDF_LANG_TE  =  "te"     ; Tegulu 
  #HPDF_LANG_TG  =  "tg"     ; Tajik 
  #HPDF_LANG_TH  =  "th"     ; Thai 
  #HPDF_LANG_TI  =  "ti"     ; Tigrinya 
  #HPDF_LANG_TK  =  "tk"     ; Turkmen 
  #HPDF_LANG_TL  =  "tl"     ; Tagalog 
  #HPDF_LANG_TN  =  "tn"     ; Setswanato Tonga 
  #HPDF_LANG_TR  =  "tr"     ; Turkish 
  #HPDF_LANG_TS  =  "ts"     ; Tsonga 
  #HPDF_LANG_TT  =  "tt"     ; Tatar 
  #HPDF_LANG_TW  =  "tw"     ; Twi 
  #HPDF_LANG_UK  =  "uk"     ; Ukrainian 
  #HPDF_LANG_UR  =  "ur"     ; Urdu 
  #HPDF_LANG_UZ  =  "uz"     ; Uzbek 
  #HPDF_LANG_VI  =  "vi"     ; Vietnamese 
  #HPDF_LANG_VO  =  "vo"     ; Volapuk 
  #HPDF_LANG_WO  =  "wo"     ; Wolof 
  #HPDF_LANG_XH  =  "xh"     ; Xhosa 
  #HPDF_LANG_YO  =  "yo"     ; Yoruba 
  #HPDF_LANG_ZH  =  "zh"     ; Chinese 
  #HPDF_LANG_ZU  =  "zu"     ; Zulu 
  ;}
  
  #HPDF_GMODE_PAGE_DESCRIPTION   = 1
  #HPDF_GMODE_PATH_OBJECT        = 2
  #HPDF_GMODE_TEXT_OBJECT        = 4
  #HPDF_GMODE_CLIPPING_PATH      = 8
  #HPDF_GMODE_SHADING            = 16
  #HPDF_GMODE_INLINE_IMAGE       = 32
  #HPDF_GMODE_EXTERNAL_OBJECT    = 64
  
  ; Error Codes
  Enumeration 4097
    #HPDF_ARRAY_COUNT_ERR ; Internal error. The consistency of the Data was lost. 
    #HPDF_ARRAY_ITEM_NOT_FOUND ; Internal error. The consistency of the Data was lost.  
    #HPDF_ARRAY_ITEM_UNEXPECTED_TYPE ; Internal error. The consistency of the Data was lost.  
    #HPDF_BINARY_LENGTH_ERR ; The length of the Data exceeds HPDF_LIMIT_MAX_STRING_LEN.
    #HPDF_CANNOT_GET_PALLET ; Cannot get a pallet Data from PNG image.  
    #HPDF_NOT_INFO_1; -- not documented
    #HPDF_DICT_COUNT_ERR ; The count of elements of a dictionary exceeds HPDF_LIMIT_MAX_DICT_ELEMENT
    #HPDF_DICT_ITEM_NOT_FOUND ; Internal error. The consistency of the Data was lost.  
    #HPDF_DICT_ITEM_UNEXPECTED_TYPE ;0 Internal error. The consistency of the Data was lost.  
    #HPDF_DICT_STREAM_LENGTH_NOT_FOUND ; Internal error. The consistency of the Data was lost.  
    #HPDF_DOC_ENCRYPTDICT_NOT_FOUND ; HPDF_SetPermission() Or HPDF_SetEncryptMode() was called before a password is set.
    #HPDF_DOC_INVALID_OBJECT ; Internal error. The consistency of the Data was lost.  
    #HPDF_NOT_INFO_2; -- not documented 
    #HPDF_DUPLICATE_REGISTRATION ;Tried To register a font that has been registered. 
    #HPDF_EXCEED_JWW_CODE_NUM_LIMIT ;  Cannot register a character To the japanese word wrap characters list.
    #HPDF_NOT_INFO_3; ----not documented  0x1010 
    #HPDF_ENCRYPT_INVALID_PASSWORD ; Tried To set the owner password To NULL.The owner password And user password is the same.  
    #HPDF_ERR_UNKNOWN_CLASS ;Internal error. The consistency of the Data was lost.  
    #HPDF_EXCEED_GSTATE_LIMIT ; The depth of the stack exceeded HPDF_LIMIT_MAX_GSTATE.
    #HPDF_FAILD_TO_ALLOC_MEM ; Memory allocation failed.
    #HPDF_FILE_IO_ERROR ; File processing failed. (A detailed code is set.)
    #HPDF_FILE_OPEN_ERROR ; Cannot open a file. (A detailed code is set.)
    #HPDF_NOT_INFO_4; ----not documented 0x1018 
    #HPDF_FONT_EXISTS ; Tried To load a font that has been registered.  
    #HPDF_FONT_INVALID_WIDTHS_TABLE; The format of a font-file is invalid .Internal error. The consistency of the Data was lost.  
    #HPDF_INVALID_AFM_HEADER ; Cannot recognize a header of an afm file.
    #HPDF_INVALID_ANNOTATION ; The specified annotation handle is invalid. 
    #HPDF_NOT_INFO_5; ----not documented 0x101D 
    #HPDF_INVALID_BIT_PER_COMPONENT ; Bit-per-component of a image which was set As mask-image is invalid.
    #HPDF_INVALID_CHAR_MATRICS_DATA ; Cannot recognize char-matrics-Data  of an afm file.  
    #HPDF_INVALID_COLOR_SPACE ;1. The color_space parameter of HPDF_LoadRawImage is invalid.
                              ;2. Color-space of a image which was set As mask-image is invalid.
                              ;3. The function which is invalid in the present color-space was invoked.
     #HPDF_INVALID_COMPRESSION_MODE ;Invalid value was set when invoking HPDF_SetCommpressionMode().
    #HPDF_INVALID_DATE_TIME ;An invalid date-time value was set.
    #HPDF_INVALID_DESTINATION ;An invalid destination handle was set.
    #HPDF_NOT_INFO_6; ----not documented 0x1024 
    #HPDF_INVALID_DOCUMENT ;An invalid document handle is set.  
    #HPDF_INVALID_DOCUMENT_STATE ;The function which is invalid in the present state was invoked.  
    #HPDF_INVALID_ENCODER ;An invalid encoder handle is set.  
    #HPDF_INVALID_ENCODER_TYPE;A combination between font And encoder is wrong.
    #HPDF_NOT_INFO_7; ---not documented 0x1029 
    #HPDF_NOT_INFO_8; ---not documented  0x102A 
    #HPDF_INVALID_ENCODING_NAME;An Invalid encoding name is specified.
    #HPDF_INVALID_ENCRYPT_KEY_LEN;The lengh of the key of encryption is invalid.
    #HPDF_INVALID_FONTDEF_DATA ;1. An invalid font handle was set.
                               ;2. Unsupported font format.
    #HPDF_INVALID_FONTDEF_TYPE ;Internal error. The consistency of the Data was lost.  
    #HPDF_INVALID_FONT_NAME ;A font which has the specified name is Not found.
    #HPDF_INVALID_IMAGE ;Unsupported image format.
    #HPDF_INVALID_JPEG_DATA ;Unsupported image format.  
    #HPDF_INVALID_N_DATA ;Cannot Read a postscript-name from an afm file.  
    #HPDF_INVALID_OBJECT ; 1. An invalid object is set.
                         ; 2. Internal error. The consistency of the Data was lost.  
    #HPDF_INVALID_OBJ_ID ;Internal error. The consistency of the Data was lost.  
    #HPDF_INVALID_OPERATION ;1. Invoked HPDF_Image_SetColorMask() against the image-object which was set a mask-image.
    #HPDF_INVALID_OUTLINE ;An invalid outline-handle was specified.
    #HPDF_INVALID_PAGE ; An invalid page-handle was specified.
    #HPDF_INVALID_PAGES ;An invalid pages-handle was specified. (internel error)
    #HPDF_INVALID_PARAMETER ;An invalid value is set.
    #HPDF_NOT_INFO_9; ---not documented  0x103A 
    #HPDF_INVALID_PNG_IMAGE ;Invalid PNG image format.  
    #HPDF_INVALID_STREAM ; Internal error. The consistency of the Data was lost.  
    #HPDF_MISSING_FILE_NAME_ENTRY;  Internal error. The "_FILE_NAME" entry For delayed loading is missing.  
    #HPDF_NOT_INFO_10; ---not documented  0x103E 
    #HPDF_INVALID_TTC_FILE ; Invalid .TTC file format.
    #HPDF_INVALID_TTC_INDEX ; The index parameter was exceed the number of included fonts
    #HPDF_INVALID_WX_DATA ;Cannot Read a width-Data from an afm file.  
    #HPDF_ITEM_NOT_FOUND ; Internal error. The consistency of the Data was lost.  
    #HPDF_LIBPNG_ERROR ; An error has returned from PNGLIB While loading an image.
    #HPDF_NAME_INVALID_VALUE ; Internal error. The consistency of the Data was lost.  
    #HPDF_NAME_OUT_OF_RANGE ;Internal error. The consistency of the Data was lost.  
    #HPDF_NOT_INFO_11; ---not documented  0x1046 
    #HPDF_NOT_INFO_12; ---not documented  0x1047 
    #HPDF_NOT_INFO_13; ---not documented  0x1048 
    #HPDF_PAGES_MISSING_KIDS_ENTRY ;Internal error. The consistency of the Data was lost.  
    #HPDF_PAGE_CANNOT_FIND_OBJECT ;Internal error. The consistency of the Data was lost.  
    #HPDF_PAGE_CANNOT_GET_ROOT_PAGES ;Internal error. The consistency of the Data was lost.  
    #HPDF_PAGE_CANNOT_RESTORE_GSTATE ;There are no graphics-states To be restored.
    #HPDF_PAGE_CANNOT_SET_PARENT ;Internal error. The consistency of the Data was lost.  
    #HPDF_PAGE_FONT_NOT_FOUND ;The current font is Not set.
    #HPDF_PAGE_INVALID_FONT ;An invalid font-handle was spacified.
    #HPDF_PAGE_INVALID_FONT_SIZE;An invalid font-size was set.
    #HPDF_PAGE_INVALID_GMODE ;See Graphics mode.
    #HPDF_PAGE_INVALID_INDEX ;Internal error. The consistency of the Data was lost.  
    #HPDF_PAGE_INVALID_ROTATE_VALUE;The specified value is Not a multiple of 90. 
    #HPDF_PAGE_INVALID_SIZE ;An invalid page-size was set.  
    #HPDF_PAGE_INVALID_XOBJECT ;An invalid image-handle was set.
    #HPDF_PAGE_OUT_OF_RANGE; The specified value is out of range.
    #HPDF_REAL_OUT_OF_RANGE; The specified value is out of range.  
    #HPDF_STREAM_EOF ; Unexpected EOF marker was detected.
    #HPDF_STREAM_READLN_CONTINUE; Internal error. The consistency of the Data was lost.  
    #HPDF_NOT_INFO_14; ---not documented  0x105A 
    #HPDF_STRING_OUT_OF_RANGE ;The length of the specified text is too long.
    #HPDF_THIS_FUNC_WAS_SKIPPED ;The execution of a function was skipped because of other errors.
    #HPDF_TTF_CANNOT_EMBEDDING_FONT ; This font cannot be embedded. (restricted by license)
    #HPDF_TTF_INVALID_CMAP ;Unsupported ttf format. (cannot find unicode cmap.)
    #HPDF_TTF_INVALID_FOMAT; Unsupported ttf format.  
    #HPDF_TTF_MISSING_TABLE ; Unsupported ttf format. (cannot find a necessary table)  
    #HPDF_UNSUPPORTED_FONT_TYPE;Internal error. The consistency of the Data was lost.  
    #HPDF_UNSUPPORTED_FUNC ;1. The library is Not configured To use PNGLIB.
                           ;2. Internal error. The consistency of the Data was lost. 
    #HPDF_UNSUPPORTED_JPEG_FORMAT ;Unsupported Jpeg format.  
    #HPDF_UNSUPPORTED_TYPE1_FONT ;Failed To parse .PFB file.
    #HPDF_XREF_COUNT_ERR ;Internal error. The consistency of the Data was lost.  
    #HPDF_ZLIB_ERROR ;An error has occurred While executing a function of Zlib.
    #HPDF_INVALID_PAGE_INDEX ;An error returned from Zlib.
    #HPDF_INVALID_URI ;An invalid URI was set.
    #HPDF_PAGELAYOUT_OUT_OF_RANGE;An invalid page-layout was set.
    #HPDF_PAGEMODE_OUT_OF_RANGE ;An invalid page-mode was set.
    #HPDF_PAGENUM_STYLE_OUT_OF_RANGE;An invalid page-num-style was set.
    #HPDF_ANNOT_INVALID_ICON ;An invalid icon was set.
    #HPDF_ANNOT_INVALID_BORDER_STYLE ;An invalid border-style was set.
    #HPDF_PAGE_INVALID_DIRECTION ;An invalid page-direction was set.
    #HPDF_INVALID_FONT ;An invalid font-handle was specified. 
  EndEnumeration
  Enumeration 0
    #HPDF_PAGE_MODE_USE_NONE
    #HPDF_PAGE_MODE_USE_OUTLINE
    #HPDF_PAGE_MODE_USE_THUMBS
    #HPDF_PAGE_MODE_FULL_SCREEN
  EndEnumeration
  Enumeration 0
    #HPDF_PAGE_NUM_STYLE_DECIMAL
    #HPDF_PAGE_NUM_STYLE_UPPER_ROMAN
    #HPDF_PAGE_NUM_STYLE_LOWER_ROMAN
    #HPDF_PAGE_NUM_STYLE_UPPER_LETTERS
    #HPDF_PAGE_NUM_STYLE_LOWER_LETTERS
  EndEnumeration
;   Enumeration 0
;     #HPDF_ENABLE_READ
;     #HPDF_ENABLE_PRINT
;     #HPDF_ENABLE_EDIT_ALL
;     #HPDF_ENABLE_COPY
;     #HPDF_ENABLE_EDIT 
;   EndEnumeration
  Enumeration 2
    #HPDF_ENCRYPT_R2
    #HPDF_ENCRYPT_R3
  EndEnumeration
  Enumeration 0
    #HPDF_COMP_NONE
    #HPDF_COMP_TEXT
    #HPDF_COMP_IMAGE
    ;#HPDF_COMP_METADATA
    ;#HPDF_COMP_ALL
  EndEnumeration
  Enumeration 0
    #HPDF_PAGE_LAYOUT_SINGLE
    #HPDF_PAGE_LAYOUT_ONE_COLUMN
    #HPDF_PAGE_LAYOUT_TWO_COLUMN_LEFT
    #HPDF_PAGE_LAYOUT_TWO_COLUMN_RIGHT
  EndEnumeration
  Enumeration 0
    #HPDF_PAGE_SIZE_LETTER
    #HPDF_PAGE_SIZE_LEGAL
    #HPDF_PAGE_SIZE_A3
    #HPDF_PAGE_SIZE_A4
    #HPDF_PAGE_SIZE_A5
    #HPDF_PAGE_SIZE_B4
    #HPDF_PAGE_SIZE_B5
    #HPDF_PAGE_SIZE_EXECUTIVE
    #HPDF_PAGE_SIZE_US4x6
    #HPDF_PAGE_SIZE_US4x8
    #HPDF_PAGE_SIZE_US5x7
    #HPDF_PAGE_SIZE_COMM10
  EndEnumeration
  Enumeration 0
    #HPDF_PAGE_PORTRAIT
    #HPDF_PAGE_LANDSCAPE
  EndEnumeration
  Enumeration 0
    #HPDF_TS_WIPE_RIGHT 
    #HPDF_TS_WIPE_UP 
    #HPDF_TS_WIPE_LEFT 
    #HPDF_TS_WIPE_DOWN 
    #HPDF_TS_BARN_DOORS_HORIZONTAL_OUT 
    #HPDF_TS_BARN_DOORS_HORIZONTAL_IN 
    #HPDF_TS_BARN_DOORS_VERTICAL_OUT 
    #HPDF_TS_BARN_DOORS_VERTICAL_IN 
    #HPDF_TS_BOX_OUT 
    #HPDF_TS_BOX_IN 
    #HPDF_TS_BLINDS_HORIZONTAL 
    #HPDF_TS_BLINDS_VERTICAL 
    #HPDF_TS_DISSOLVE 
    #HPDF_TS_GLITTER_RIGHT 
    #HPDF_TS_GLITTER_DOWN 
    #HPDF_TS_GLITTER_TOP_LEFT_TO_BOTTOM_RIGHT 
    #HPDF_TS_REPLACE
  EndEnumeration
  Enumeration 0
    #HPDF_BUTT_END
    #HPDF_ROUND_END
    #HPDF_PROJECTING_SCUARE_END
  EndEnumeration
  Enumeration 0
    #HPDF_MITER_JOIN
    #HPDF_ROUND_JOIN
    #HPDF_BEVEL_JOIN
  EndEnumeration
  Enumeration 0
    #HPDF_FILL
    #HPDF_STROKE
    #HPDF_FILL_THEN_STROKE
    #HPDF_INVISIBLE
    #HPDF_FILL_CLIPPING
    #HPDF_STROKE_CLIPPING
    #HPDF_FILL_STROKE_CLIPPING
    #HPDF_CLIPPING
  EndEnumeration
  Enumeration 0
    #HPDF_TALIGN_LEFT
    #HPDF_TALIGN_RIGHT
    #HPDF_TALIGN_CENTER
    #HPDF_TALIGN_JUSTIFY
  EndEnumeration
  Enumeration 0
    #HPDF_ENCODER_TYPE_SINGLE_BYTE
    #HPDF_ENCODER_TYPE_DOUBLE_BYTE
    #HPDF_ENCODER_TYPE_UNINITIALIZED
    #HPDF_ENCODER_UNKNOWN
  EndEnumeration
  Enumeration 0
    #HPDF_BYTE_TYPE_SINGLE
    #HPDF_BYTE_TYPE_LEAD
    #HPDF_BYTE_TYPE_TRIAL
    #HPDF_BYTE_TYPE_UNKNOWN
  EndEnumeration
  Enumeration 0
    #HPDF_WMODE_HORIZONTAL
    #HPDF_WMODE_VERTICAL
  EndEnumeration
  Enumeration 0
    #HPDF_ANNOT_NO_HIGHTLIGHT
    #HPDF_ANNOT_INVERT_BOX
    #HPDF_ANNOT_INVERT_BORDER
    #HPDF_ANNOT_DOWN_APPEARANCE
  EndEnumeration
  Enumeration 0
    #HPDF_ANNOT_ICON_COMMENT 
    #HPDF_ANNOT_ICON_KEY 
    #HPDF_ANNOT_ICON_NOTE 
    #HPDF_ANNOT_ICON_HELP 
    #HPDF_ANNOT_ICON_NEW_PARAGRAPH 
    #HPDF_ANNOT_ICON_PARAGRAPH 
    #HPDF_ANNOT_ICON_INSERT
  EndEnumeration
  Enumeration 0
    #HPDF_BM_NORMAL 
    #HPDF_BM_MULTIPLY 
    #HPDF_BM_SCREEN 
    #HPDF_BM_OVERLAY 
    #HPDF_BM_DARKEN 
    #HPDF_BM_LIGHTEN 
    #HPDF_BM_COLOR_DODGE 
    #HPDF_BM_COLOR_BUM 
    #HPDF_BM_HARD_LIGHT 
    #HPDF_BM_SOFT_LIGHT 
    #HPDF_BM_DIFFERENCE 
    #HPDF_BM_EXCLUSHON 
  EndEnumeration
  Enumeration 0
    #HPDF_CS_DEVICE_GRAY 
    #HPDF_CS_DEVICE_RGB
    #HPDF_CS_DEVICE_CMYK
    #HPDF_CS_CAL_GRAY
    #HPDF_CS_CAL_RGB
    #HPDF_CS_LAB
    #HPDF_CS_ICC_BASED
    #HPDF_CS_SEPARATION
    #HPDF_CS_DEVICE_N
    #HPDF_CS_INDEXED
    #HPDF_CS_PATTERN
    #HPDF_CS_EOF
  EndEnumeration
;}
;{ Structures
  Structure HPDF_Error_Handler 
    error_no.l
    detail_no.l
  EndStructure
  Structure HPDF_Date
    year.l
    month.l
    day.l
    hour.l
    minutes.l
    seconds.l
    ind.c
    off_hour.l
    off_minutes.l
  EndStructure
  Structure HPDF_DashMode 
    ptn.w[8]
    num_ptn.l
    phase.l
  EndStructure
  Structure HPDF_RGBColor
    r.f
    g.f
    b.f
  EndStructure
  Structure HPDF_CMYKColor
    c.f
    m.f
    y.f
    k.f
  EndStructure
  Structure HPDF_Rect
    left.f
    bottom.f
    right.f
    top.f
  EndStructure
  Structure HPDF_TextWidth
    numchars.l
    numwords.l
    width.l
    numspace.l
  EndStructure
  Structure HPDF_Point
    x.f
    y.f
  EndStructure
;}
;{ Prototypes
  Prototype.l HPDF_New(user_error_fn.l,*user_data.HPDF_Error_Handler)
  Prototype.l HPDF_NewEx(user_error_fn.l,user_alloc_fn.l,user_free_fn.l,mem_pool_buf_size.l,*user_data.HPDF_Error_Handler)
  Prototype.l HPDF_Free(pdf.l) 
  Prototype.l HPDF_NewDoc(pdf.l)
  Prototype.l HPDF_FreeDoc(pdf.l)
  Prototype.l HPDF_FreeDocAll(pdf.l)
  Prototype.l HPDF_SaveToFile(pdf.l,file_name.s)
  Prototype.l HPDF_SaveToStream (pdf.l)
  Prototype.l HPDF_GetStreamSize(pdf.l)
  Prototype.l HPDF_ReadFromStream(pdf.l,*buf, *buf_size)
  Prototype.l HPDF_ResetStream(pdf.l)
  Prototype.l HPDF_HasDoc(pdf.l)
  Prototype.l HPDF_SetErrorHandler(pdf.l,*user_error_fn.HPDF_Error_Handler)
  Prototype.l HPDF_GetError(pdf.l)
  Prototype.l HPDF_ResetError(pdf.l) 
  Prototype.l HPDF_SetPagesConfiguration(pdf.l,page_per_pages.l)
  Prototype.l HPDF_GetPageLayout(pdf.l)
  Prototype.l HPDF_SetPageLayout(pdf.l,  layout.l)
  Prototype.l HPDF_GetPageMode(pdf.l)
  Prototype.l HPDF_SetPageMode(pdf.l, mode.l)
  Prototype.l HPDF_SetOpenAction(pdf.l, open_action.l)
  Prototype.l HPDF_GetCurrentPage(pdf.l)
  Prototype.l HPDF_AddPage(pdf.l)
  Prototype.l HPDF_InsertPage(pdf.l,HPDF_Page.l)
  Prototype.l HPDF_GetFont( pdf.l,font_name.s, *encoding_name.s)
  Prototype.l HPDF_LoadType1FontFromFile(pdf.l,afmfilename.s,pfmfilename.s)
  Prototype.l HPDF_LoadTTFontFromFile(pdf.l,file_name.s, embedding.l)
  Prototype.l HPDF_LoadTTFontFromFile2(pdf.l,*file_name.s,index.l,embedding.l)
  Prototype.l HPDF_AddPageLabel(pdf.l, page_num.l,style.l,first_page.l,*prefix.l)
  Prototype.l HPDF_UseJPFonts(pdf.l)
  Prototype.l HPDF_UseKRFonts(pdf.l)
  Prototype.l HPDF_UseCNSFonts(pdf.l)
  Prototype.l HPDF_UseCNTFonts(pdf.l)
  Prototype.l HPDF_CreateOutline(pdf.l,parent.l,title.s,encoder.l)
  Prototype.l HPDF_GetEncoder(pdf.l, encoding_name.s)
  Prototype.l HPDF_GetCurrentEncoder(pdf.l) 
  Prototype.l HPDF_SetCurrentEncoder(pdf.l,encoding_name.s)
  Prototype.l HPDF_UseJPEncodings(pdf.l)
  Prototype.l HPDF_UseKREncodings(pdf.l)
  Prototype.l HPDF_UseCNSEncodings(pdf.l)
  Prototype.l HPDF_UseCNTEncodings(pdf.l)
  Prototype.l HPDF_CreateExtGState(pdf.l)
  Prototype.l HPDF_LoadPngImageFromFile(pdf.l,filename.s)
  Prototype.l HPDF_LoadPngImageFromFile2(pdf.l,filename.s)
  Prototype.l HPDF_LoadRawImageFromFile(pdf.l,filename.s,width.l,height.l,color_space.l)
  Prototype.l HPDF_LoadRawImageFromMem(pdf.l,*buf.l,width.l,height.l,color_space.l,bits_per_component.l)
  Prototype.l HPDF_LoadJpegImageFromFile(pdf.l, filename.s)
  Prototype.l HPDF_SetInfoAttr(pdf.l,type.l,*value.s)
  Prototype.l HPDF_GetInfoAttr(pdf.l,type.l)
  Prototype.l HPDF_SetInfoDateAttr(pdf.l,type.l,*value.HPDF_date)
  Prototype.l HPDF_SetPassword(pdf.l,owner_passwd.s,user_passwd.s)
  Prototype.l HPDF_SetPermission(pdf.l, permission.l)
  Prototype.l HPDF_SetEncryptionMode(pdf.l,mode.l,key_len.l)
  Prototype.l HPDF_SetCompressionMode(pdf.l,mode.l)

  ; Page
  Prototype.l HPDF_Page_SetWidth(page.l, width.f) ; 3 and 14400
  Prototype.l HPDF_Page_SetHeight(page.l,height.f) ; 3 and 14400
  Prototype.l HPDF_Page_SetSize(page.l,size.l,direction.l)
  Prototype.l HPDF_Page_SetRotate(page.l, angle.l)
  Prototype.f HPDF_Page_GetWidth(page.l)
  Prototype.f HPDF_Page_GetHeight(page.l)
  Prototype.l HPDF_Page_CreateDestination(page.l)
  Prototype.l HPDF_Page_CreateTextAnnot(page.l, *rect.HPDF_Rect, text.s, encoder.l)
  Prototype.l HPDF_Page_CreateLinkAnnot(page.l, *rect.HPDF_Rect, dst.l)
  Prototype.l HPDF_Page_CreateURILinkAnnot(page.l,*rect.HPDF_Rect, uri.s)
  Prototype.f HPDF_Page_TextWidth(page.l,text.s)
  Prototype.l HPDF_Page_MeasureText(page.l,text.s,width.f,wordwrap.b,*real_width.f)
  Prototype.l HPDF_Page_GetGMode(page.l)
  Prototype   HPDF_Page_GetCurrentPos(page.l)
  Prototype.l HPDF_Page_GetCurrentTextPos(page.l)
  Prototype.l HPDF_Page_GetCurrentFont(page.l)
  Prototype.f HPDF_Page_GetCurrentFontSize(page.l)
  Prototype.l HPDF_Page_GetTransMatrix(page.l)
  Prototype.l HPDF_Page_GetLineWidth(page.l)
  Prototype.l HPDF_Page_GetLineCap(page.l)
  Prototype.l HPDF_Page_GetLineJoin(page.l)
  Prototype.l HPDF_Page_GetMiterLimit(page.l)
  Prototype.l HPDF_Page_GetDash(page.l)
  Prototype.l HPDF_Page_GetFlat(page.l)
  Prototype.l HPDF_Page_GetCharSpace(page.l)
  Prototype.l HPDF_Page_GetWordSpace(page.l)
  Prototype.l HPDF_Page_GetHorizontalScalling(page.l)
  Prototype.l HPDF_Page_GetTextLeading(page.l)
  Prototype.l HPDF_Page_GetTextRenderingMode(page.l)
  Prototype.l HPDF_Page_GetTextRise(page.l) 
  Prototype.l HPDF_Page_GetRGBFill(page.l)
  Prototype.l HPDF_Page_GetRGBStroke(page.l)
  Prototype.l HPDF_Page_GetCMYKFill(page.l)
  Prototype.l HPDF_Page_GetCMYKStroke(page.l)
  Prototype.l HPDF_Page_GetGrayFill(page.l)
  Prototype.l HPDF_Page_GetGrayStroke(page.l)
  Prototype.l HPDF_Page_GetStrokingColorSpace(page.l)
  Prototype.l HPDF_Page_GetFillingColorSpace(page.l)
  Prototype.l HPDF_Page_GetTextMatrix(page.l)
  Prototype.l HPDF_Page_GetGStateDepth(page.l)
  Prototype.l HPDF_Page_SetSlideShow(page.l,type.l,disp_time.l,trans_time.l)

  ; Graphics
  Prototype.l HPDF_Page_SetLineWidth(page.l,line_width.f)
  Prototype.l HPDF_Page_SetLineCap(page.l,line_cap)
  Prototype.l HPDF_Page_SetLineJoin(page.l, line_join.l)
  Prototype.l HPDF_Page_SetDash(page.l,*dash_ptn.l,num_param.l,phase.l)
  Prototype.l HPDF_Page_SetExtGState(page.l,ext_gstate.l)
  Prototype.l HPDF_Page_GSave(page.l)
  Prototype.l HPDF_Page_GRestore(page.l)
  Prototype.l HPDF_Page_Concat(page.l,a.f,b.f,c.f,d.f,x.f,y.f)  
  Prototype.l HPDF_Page_MoveTo(page.l,x.f,y.f)
  Prototype.l HPDF_Page_LineTo(page.l,x.f,y.f)
  Prototype.l HPDF_Page_CurveTo(page.l,x1.f,y1.f,x2.f,y2.f,x3.f,y3.f)
  Prototype.l HPDF_Page_CurveTo2(page.l,x2.f,y2.f,x3.f,y3.f)
  Prototype.l HPDF_Page_CurveTo3(page.l,x1.f,y1.f,x3.f,y3.f)
  Prototype.l HPDF_Page_ClosePath(page.l)
  Prototype.l HPDF_Page_Rectangle(page.l,x.f,y.f,width.f,height.f)
  Prototype.l HPDF_Page_Stroke(page.l)
  Prototype.l HPDF_Page_ClosePathStroke(page.l)
  Prototype.l HPDF_Page_Fill(page.l)
  Prototype.l HPDF_Page_Eofill(page.l)
  Prototype.l HPDF_Page_FillStroke(page.l)
  Prototype.l HPDF_Page_EofillStroke(page.l)
  Prototype.l HPDF_Page_ClosePathFillStroke(page.l)
  Prototype.l HPDF_Page_ClosePathEoillStroke(page.l)
  Prototype.l HPDF_Page_EndPath(page.l)
  Prototype.l HPDF_Page_BeginText(page.l)
  Prototype.l HPDF_Page_EndText(page.l)
  Prototype.l HPDF_Page_SetCharSpace(page.l,value.f)
  Prototype.l HPDF_Page_SetWordSpace(page.l,value.f)
  Prototype.l HPDF_Page_SetHorizontalScalling(page.l,value.f)
  Prototype.l HPDF_Page_SetTextLeading(page.l,value.f)
  Prototype.l HPDF_Page_SetFontAndSize (page.l,font.l,size.f)
  Prototype.l HPDF_Page_SetTextRenderingMode(page.l ,mode.l)
  Prototype.l HPDF_Page_MoveTextPos(page.l, x.f,y.f)
  Prototype.l HPDF_Page_MoveTextPos2(page.l, x.f,y.f)
  Prototype.l HPDF_Page_MoveToNextLine(page.l)
  Prototype.l HPDF_Page_ShowText(page.l ,text.s)
  Prototype.l HPDF_Page_ShowTextNextLine(page.l,text.s)
  Prototype.l HPDF_Page_ShowTextNextLineEx(page.l,word_space.f,char_space.f,text.s)
  Prototype.l HPDF_Page_SetGrayFill(page.l,gray.f)
  Prototype.l HPDF_Page_SetGrayStroke(page.l,gray.f)
  Prototype.l HPDF_Page_SetRGBFill(page.l, r.f, g.f, b.f)
  Prototype.l HPDF_Page_SetRGBStroke(page.l,r.f,g.f,b.f)
  Prototype.l HPDF_Page_SetCMYKFill(page.l,c.f,m.f,y.f,k.f)
  Prototype.l HPDF_Page_SetCMYKStroke(page.l,c.f,m.f,y.f,k.f)
  Prototype.l HPDF_Page_DrawImage(page.l,image.l,x.f,y.f,width.f,height.f)
  Prototype.l HPDF_Page_Circle(page.l,x.f,y.f,ray.f)
  Prototype.l HPDF_Page_Arc(page.l,x.f,y.f,ray.f,ang1.f,ang2.f)
  Prototype.l HPDF_Page_Ellipse(page.l,x.f,y.f,xray.f,yray.f)
  Prototype.l HPDF_Page_TextOut(page.l,x.f,y.f,text.s)
  Prototype.l HPDF_Page_TextRect(page.l,left.f,bottom.f,right.f,top.f,text.s,align.l,*len.w)
  Prototype.l HPDF_Page_ExecuteXObject(page.l, image.l)
  Prototype.l HPDF_Page_Clip(page.l)
  Prototype.l HPDF_Page_SetTextMatrix(page.l,a.f,b.f,c.f,d.f,e.f,g.f)
  
  ; Font
  Prototype.l HPDF_Font_GetFontName(font.l)
  Prototype.s HPDF_Font_GetEncodingName(font.l)
  Prototype.l HPDF_Font_GetUnicodeWidth (font.l, code.l)
  Prototype.l HPDF_Font_GetBBox(font.l) 
  Prototype.l HPDF_Font_GetAscent(font.l)
  Prototype.l HPDF_Font_GetDescent(font.l)
  Prototype.l HPDF_Font_GetXHeight(font.l)
  Prototype.l HPDF_Font_GetCapHeight(font.l)
  Prototype.l HPDF_Font_TextWidth(font.l,text.l,len.w)
  Prototype.l HPDF_Font_MeasureText(font.l,text.l,len.w,width.f,font_size.f,char_space.f,word_space.f,wordwrap.b,*real_width.f)

  ; Encoder
  Prototype.l HPDF_Encoder_GetType(encoder.l)
  Prototype.l HPDF_Encoder_GetByteType(encoder.l,text.s,index.w)
  Prototype.l HPDF_Encoder_GetUnicode(encoder.l,code.w)
  Prototype.l HPDF_Encoder_GetWritingMode(encoder.l)

  ; Annotation
  Prototype.l HPDF_LinkAnnot_SetHighlightMode(annot.l,mode.l)
  Prototype.l HPDF_LinkAnnot_SetBorderStyle(annot.l,width.f,dash_on.w,dash_off.w)
  Prototype.l HPDF_TextAnnot_SetIcon(annot.l,icon.l)
  Prototype.l HPDF_TextAnnot_SetOpened(annot.l,opened.b)

  ; Outline
  Prototype.l HPDF_Outline_SetOpened(outline.l,opened.b)
  Prototype.l HPDF_Outline_SetDestination(outline.l,dst.l)

  ; Destination
  Prototype.l HPDF_Destination_SetXYZ(dst.l,left.f,top.f,zoom.f)
  Prototype.l HPDF_Destination_SetFit(dst.l)
  Prototype.l HPDF_Destination_SetFitH(dst.l,top.f)
  Prototype.l HPDF_Destination_SetFitV(dst.l,left.f)
  Prototype.l HPDF_Destination_SetFitR(dst.l,left.f,bottom.f,right.f,top.f)
  Prototype.l HPDF_Destination_SetFitB(dst.l)
  Prototype.l HPDF_Destination_SetFitBH(dst.l,top.f)
  Prototype.l HPDF_Destination_SetFitBV(dst.l,top.f)

  ; Image
  Prototype.l HPDF_Image_GetSize(image.l)
  Prototype.l HPDF_Image_GetWidth(image.l)
  Prototype.l HPDF_Image_GetHeight(image.l)
  Prototype.l HPDF_Image_GetBitsPerComponent(image.l)
  Prototype.l HPDF_Image_GetColorSpace(image.l)
  Prototype.l HPDF_Image_SetColorMask(image.l,rmin.w, rmax.w, gmin.w ,gmax.w ,bmin.w ,bmax.w)
  Prototype.l HPDF_Image_SetMaskImage(image.l, image_mask.l)

  ; ExtGState
  Prototype.l HPDF_ExtGState_SetAlphaStroke(ext_gstate.l ,value.f)
  Prototype.l HPDF_ExtGState_SetAlphaFill(ext_gstate.l ,value.f)
  Prototype.l HPDF_ExtGState_SetBlendMode(ext_gstate.l, mode.l)

;}


Procedure HaruPDF_Init(DLLName.s = "libhpdf.dll") 
   Protected Lib.l 
   Lib = OpenLibrary(#PB_Any, DLLName)
   If Lib <> 0 
    Global HPDF_new.HPDF_New = GetFunction(Lib,"HPDF_New")
    Global HPDF_NewEx.HPDF_NewEx = GetFunction(Lib,"HPDF_NewEx")
    Global HPDF_Free.HPDF_Free = GetFunction(Lib,"HPDF_Free")
    Global HPDF_NewDoc.HPDF_NewDoc = GetFunction(Lib,"HPDF_NewDoc")
    Global HPDF_FreeDoc.HPDF_FreeDoc = GetFunction(Lib,"HPDF_FreeDoc")
    Global HPDF_FreeDocAll.HPDF_FreeDocAll = GetFunction(Lib,"HPDF_FreeDocAll")
    Global HPDF_SaveToFile.HPDF_SaveToFile = GetFunction(Lib,"HPDF_SaveToFile")
    Global HPDF_SaveToStream.HPDF_SaveToStream  = GetFunction(Lib,"HPDF_SaveToStream")
    Global HPDF_GetStreamSize.HPDF_GetStreamSize = GetFunction(Lib,"HPDF_GetStreamSize")
    Global HPDF_ReadFromStream.HPDF_ReadFromStream = GetFunction(Lib, "HPDF_ReadFromStream")
    Global HPDF_ResetStream.HPDF_ResetStream = GetFunction(Lib,"HPDF_ResetStream")
    Global HPDF_HasDoc.HPDF_HasDoc = GetFunction(Lib,"HPDF_HasDoc")
    Global HPDF_SetErrorHandler.HPDF_SetErrorHandler = GetFunction(Lib,"HPDF_SetErrorHandler")
    Global HPDF_GetError.HPDF_GetError = GetFunction(Lib,"HPDF_GetError")
    Global HPDF_ResetError.HPDF_ResetError  = GetFunction(Lib, "HPDF_ResetError")
    Global HPDF_SetPagesConfiguration.HPDF_SetPagesConfiguration = GetFunction(Lib, "HPDF_SetPagesConfiguration")
    Global HPDF_GetPageLayout.HPDF_GetPageLayout = GetFunction(Lib,"HPDF_GetPageLayout")
    Global HPDF_SetPageLayout.HPDF_SetPageLayout = GetFunction(Lib, "HPDF_SetPageLayout")
    Global HPDF_GetPageMode.HPDF_GetPageMode = GetFunction(Lib,"HPDF_SetPageMode")
    Global HPDF_SetPageMode.HPDF_SetPageMode = GetFunction(Lib, "HPDF_SetPageMode")
    Global HPDF_SetOpenAction.HPDF_SetOpenAction = GetFunction(Lib,"HPDF_SetOpenAction")
    Global HPDF_GetCurrentPage.HPDF_GetCurrentPage = GetFunction(Lib,"HPDF_GetCurrentPage")
    Global HPDF_AddPage.HPDF_AddPage = GetFunction(Lib,"HPDF_AddPage")
    Global HPDF_InsertPage.HPDF_InsertPage = GetFunction(Lib,"HPDF_InsertPage")
    Global HPDF_GetFont.HPDF_GetFont = GetFunction(Lib,"HPDF_GetFont")
    Global HPDF_LoadType1FontFromFile.HPDF_LoadType1FontFromFile = GetFunction(Lib,"HPDF_LoadType1FontFromFile")
    Global HPDF_LoadTTFontFromFile.HPDF_LoadTTFontFromFile = GetFunction(Lib,"HPDF_LoadTTFontFromFile")
    Global HPDF_LoadTTFontFromFile2.HPDF_LoadTTFontFromFile2 = GetFunction(lib,"HPDF_LoadTTFontFromFile2")
    Global HPDF_AddPageLabel.HPDF_AddPageLabel = GetFunction(lib,"HPDF_AddPageLabel")
    Global HPDF_UseJPFonts.HPDF_UseJPFonts = GetFunction(lib,"HPDF_UseJPFonts")
    Global HPDF_UseKRFonts.HPDF_UseKRFonts = GetFunction(lib, "HPDF_UseKRFonts")
    Global HPDF_UseCNSFonts.HPDF_UseCNSFonts = GetFunction(lib, "HPDF_UseCNSFonts")
    Global HPDF_UseCNTFonts.HPDF_UseCNTFonts = GetFunction(lib, "HPDF_UseCNTFonts")
    Global HPDF_CreateOutline.HPDF_CreateOutline = GetFunction(lib, "HPDF_CreateOutline")
    Global HPDF_GetEncoder.HPDF_GetEncoder = GetFunction(lib,"HPDF_GetEncoder") 
    Global HPDF_GetCurrentEncoder.HPDF_GetCurrentEncoder  = GetFunction (lib, "HPDF_GetCurrentEncoder")
    Global HPDF_SetCurrentEncoder.HPDF_SetCurrentEncoder = GetFunction(lib,"HPDF_SetCurrentEncoder")
    Global HPDF_UseJPEncodings.HPDF_UseJPEncodings = GetFunction(lib,"HPDF_UseJPEncodings")
    Global HPDF_UseKREncodings.HPDF_UseKREncodings = GetFunction(lib,"HPDF_UseKREncodings")
    Global HPDF_UseCNSEncodings.HPDF_UseCNSEncodings = GetFunction(lib, "HPDF_UseCNSEncodings")
    Global HPDF_UseCNTEncodings.HPDF_UseCNTEncodings = GetFunction(lib,"HPDF_UseCNTEncodings")
    Global HPDF_CreateExtGState.HPDF_CreateExtGState = GetFunction(lib, "HPDF_CreateExtGState")
    Global HPDF_LoadPngImageFromFile.HPDF_LoadPngImageFromFile = GetFunction(lib,"HPDF_LoadPngImageFromFile")
    Global HPDF_LoadPngImageFromFile2.HPDF_LoadPngImageFromFile2 = GetFunction(lib,"HPDF_LoadPngImageFromFile2")
    Global HPDF_LoadRawImageFromFile.HPDF_LoadRawImageFromFile = GetFunction (lib,"HPDF_LoadRawImageFromFile")
    Global HPDF_LoadRawImageFromMem.HPDF_LoadRawImageFromMem = GetFunction (lib,"HPDF_LoadRawImageFromMem")
    Global HPDF_LoadJpegImageFromFile.HPDF_LoadJpegImageFromFile = GetFunction (lib, "HPDF_LoadJpegImageFromFile")
    Global HPDF_SetInfoAttr.HPDF_SetInfoAttr = GetFunction(lib,"HPDF_SetInfoAttr")
    Global HPDF_GetInfoAttr.HPDF_GetInfoAttr = GetFunction(lib,"HPDF_GetInfoAttr")
    Global HPDF_SetInfoDateAttr.HPDF_SetInfoDateAttr = GetFunction(lib,"HPDF_SetInfoDateAttr")
    Global HPDF_SetPassword.HPDF_SetPassword = GetFunction(lib,"HPDF_SetPassword")
    Global HPDF_SetPermission.HPDF_SetPermission = GetFunction(lib,"HPDF_SetPermission")
    Global HPDF_SetEncryptionMode.HPDF_SetEncryptionMode = GetFunction(lib,"HPDF_SetEncryptionMode")
    Global HPDF_SetCompressionMode.HPDF_SetCompressionMode = GetFunction(lib,"HPDF_SetCompressionMode")
    ; Page
    Global HPDF_Page_SetWidth.HPDF_Page_SetWidth = GetFunction(lib,"HPDF_Page_SetWidth")
    Global HPDF_Page_SetHeight.HPDF_Page_SetHeight = GetFunction(lib,"HPDF_Page_SetHeight")
    Global HPDF_Page_SetSize.HPDF_Page_SetSize = GetFunction(lib,"HPDF_Page_SetSize")
    Global HPDF_Page_SetRotate.HPDF_Page_SetRotate= GetFunction(lib,"HPDF_Page_SetRotate")
    Global HPDF_Page_GetWidth.HPDF_Page_GetWidth= GetFunction(lib,"HPDF_Page_GetWidth")
    Global HPDF_Page_GetHeight.HPDF_Page_GetHeight= GetFunction(lib,"HPDF_Page_GetHeight")
    Global HPDF_Page_CreateDestination.HPDF_Page_CreateDestination= GetFunction(lib,"HPDF_Page_CreateDestination")
    Global HPDF_Page_CreateTextAnnot.HPDF_Page_CreateTextAnnot = GetFunction(lib,"HPDF_Page_CreateTextAnnot")
    Global HPDF_Page_CreateLinkAnnot.HPDF_Page_CreateLinkAnnot = GetFunction(lib,"HPDF_Page_CreateLinkAnnot")
    Global HPDF_Page_CreateURILinkAnnot.HPDF_Page_CreateURILinkAnnot = GetFunction(lib,"HPDF_Page_CreateURILinkAnnot")
    Global HPDF_Page_TextWidth.HPDF_Page_TextWidth = GetFunction(lib,"HPDF_Page_TextWidth")
    Global HPDF_Page_MeasureText.HPDF_Page_MeasureText = GetFunction(lib,"HPDF_Page_MeasureText")
    Global HPDF_Page_GetGMode.HPDF_Page_GetGMode = GetFunction(lib,"HPDF_Page_GetGMode")
    Global HPDF_Page_GetCurrentPos.HPDF_Page_GetCurrentPos = GetFunction(lib,"HPDF_Page_GetCurrentPos")
    Global HPDF_Page_GetCurrentTextPos.HPDF_Page_GetCurrentTextPos = GetFunction(lib,"HPDF_Page_GetCurrentTextPos")
    Global HPDF_Page_GetCurrentFont.HPDF_Page_GetCurrentFont = GetFunction(lib,"HPDF_Page_GetCurrentFont")
    Global HPDF_Page_GetCurrentFontSize.HPDF_Page_GetCurrentFontSize = GetFunction(lib,"HPDF_Page_GetCurrentFontSize")
    Global HPDF_Page_GetTransMatrix.HPDF_Page_GetTransMatrix = GetFunction(lib,"HPDF_Page_GetTransMatrix")
    Global HPDF_Page_GetLineWidth.HPDF_Page_GetLineWidth = GetFunction(lib,"HPDF_Page_GetLineWidth")
    Global HPDF_Page_GetLineCap.HPDF_Page_GetLineCap = GetFunction(lib,"HPDF_Page_GetLineCap")
    Global HPDF_Page_GetLineJoin.HPDF_Page_GetLineJoin = GetFunction(lib,"HPDF_Page_GetLineJoin")
    Global HPDF_Page_GetMiterLimit.HPDF_Page_GetMiterLimit = GetFunction(lib,"HPDF_Page_GetMiterLimit")
    Global HPDF_Page_GetDash.HPDF_Page_GetDash = GetFunction(lib,"HPDF_Page_GetDash")
    Global HPDF_Page_GetDash.HPDF_Page_GetDash = GetFunction(lib,"HPDF_Page_GetDash")
    Global HPDF_Page_GetFlat.HPDF_Page_GetFlat = GetFunction(lib,"HPDF_Page_GetFlat")
    Global HPDF_Page_GetCharSpace.HPDF_Page_GetCharSpace = GetFunction(lib,"HPDF_Page_GetCharSpace")
    Global HPDF_Page_GetWordSpace.HPDF_Page_GetWordSpace = GetFunction(lib,"HPDF_Page_GetWordSpace")
    Global HPDF_Page_GetHorizontalScalling.HPDF_Page_GetHorizontalScalling = GetFunction(lib,"HPDF_Page_GetHorizontalScalling")
    Global HPDF_Page_GetTextLeading.HPDF_Page_GetTextLeading = GetFunction(lib,"HPDF_Page_GetTextLeading")
    Global HPDF_Page_GetTextRenderingMode.HPDF_Page_GetTextRenderingMode = GetFunction(lib,"HPDF_Page_GetTextRenderingMode")
    Global HPDF_Page_GetTextRise.HPDF_Page_GetTextRise = GetFunction(lib,"HPDF_Page_GetTextRise")
    Global HPDF_Page_GetRGBFill.HPDF_Page_GetRGBFill = GetFunction(lib,"HPDF_Page_GetRGBFill")
    Global HPDF_Page_GetRGBStroke.HPDF_Page_GetRGBStroke = GetFunction(lib,"HPDF_Page_GetRGBStroke")
    Global HPDF_Page_GetCMYKFill.HPDF_Page_GetCMYKFill = GetFunction(lib,"HPDF_Page_GetCMYKFill") 
    Global HPDF_Page_GetCMYKStroke.HPDF_Page_GetCMYKStroke = GetFunction(lib,"HPDF_Page_GetCMYKStroke")
    Global HPDF_Page_GetGrayFill.HPDF_Page_GetGrayFill = GetFunction(lib,"HPDF_Page_GetGrayFill")
    Global HPDF_Page_GetGrayStroke.HPDF_Page_GetGrayStroke  = GetFunction(lib,"HPDF_Page_GetGrayStroke")
    Global HPDF_Page_GetStrokingColorSpace.HPDF_Page_GetStrokingColorSpace = GetFunction(lib,"HPDF_Page_GetStrokingColorSpace")
    Global HPDF_Page_GetFillingColorSpace.HPDF_Page_GetFillingColorSpace = GetFunction(lib,"HPDF_Page_GetFillingColorSpace")
    Global HPDF_Page_GetTextMatrix.HPDF_Page_GetTextMatrix = GetFunction(lib,"HPDF_Page_GetTextMatrix")
    Global HPDF_Page_GetGStateDepth.HPDF_Page_GetGStateDepth =GetFunction(lib,"HPDF_Page_GetGStateDepth")
    Global HPDF_Page_SetSlideShow.HPDF_Page_SetSlideShow = GetFunction(lib,"HPDF_Page_SetSlideShow")
    Global HPDF_Page_ExecuteXObject.HPDF_Page_ExecuteXObject = GetFunction(lib,"HPDF_Page_ExecuteXObject")
    Global HPDF_Page_Clip.HPDF_Page_Clip = GetFunction(lib,"HPDF_Page_Clip")
    ; Graphics
    Global HPDF_Page_SetLineWidth.HPDF_Page_SetLineWidth = GetFunction(lib,"HPDF_Page_SetLineWidth")
    Global HPDF_Page_SetLineCap.HPDF_Page_SetLineCap = GetFunction(lib,"HPDF_Page_SetLineCap")
    Global HPDF_Page_SetLineJoin.HPDF_Page_SetLineJoin = GetFunction(lib,"HPDF_Page_SetLineJoin")
    Global HPDF_Page_SetDash.HPDF_Page_SetDash  = GetFunction(lib,"HPDF_Page_SetDash")
    Global HPDF_Page_SetExtGState.HPDF_Page_SetExtGState = GetFunction(lib,"HPDF_Page_SetExtGState")
    Global HPDF_Page_SetExtGState.HPDF_Page_SetExtGState = GetFunction(lib,"HPDF_Page_SetExtGState")
    Global HPDF_Page_GSave.HPDF_Page_GSave = GetFunction(lib,"HPDF_Page_GSave")
    Global HPDF_Page_GRestore.HPDF_Page_GRestore = GetFunction(lib,"HPDF_Page_GRestore")
    Global HPDF_Page_Concat.HPDF_Page_Concat = GetFunction(lib,"HPDF_Page_Concat")
    Global HPDF_Page_MoveTo.HPDF_Page_MoveTo = GetFunction(lib,"HPDF_Page_MoveTo")
    Global HPDF_Page_LineTo.HPDF_Page_LineTo = GetFunction(lib,"HPDF_Page_LineTo")
    Global HPDF_Page_CurveTo.HPDF_Page_CurveTo = GetFunction(lib,"HPDF_Page_CurveTo")
    Global HPDF_Page_CurveTo2.HPDF_Page_CurveTo2 = GetFunction(lib,"HPDF_Page_CurveTo2")
    Global HPDF_Page_CurveTo3.HPDF_Page_CurveTo3 = GetFunction(lib,"HPDF_Page_CurveTo3")
    Global HPDF_Page_ClosePath.HPDF_Page_ClosePath = GetFunction(lib,"HPDF_Page_ClosePath")
    Global HPDF_Page_Rectangle.HPDF_Page_Rectangle = GetFunction(lib,"HPDF_Page_Rectangle")
    Global HPDF_Page_Stroke.HPDF_Page_Stroke = GetFunction(lib,"HPDF_Page_Stroke")
    Global HPDF_Page_ClosePathStroke.HPDF_Page_ClosePathStroke = GetFunction(lib,"HPDF_Page_ClosePathStroke")
    Global HPDF_Page_Fill.HPDF_Page_Fill = GetFunction(lib,"HPDF_Page_Fill")
    Global HPDF_Page_Eofill.HPDF_Page_Eofill = GetFunction(lib,"HPDF_Page_Eofill")
    Global HPDF_Page_FillStroke.HPDF_Page_FillStroke = GetFunction(lib,"HPDF_Page_FillStroke")
    Global HPDF_Page_EofillStroke.HPDF_Page_EofillStroke = GetFunction(lib,"HPDF_Page_EofillStroke")
    Global HPDF_Page_ClosePathFillStroke.HPDF_Page_ClosePathFillStroke = GetFunction(lib,"HPDF_Page_ClosePathFillStroke")
    Global HPDF_Page_ClosePathEoillStroke.HPDF_Page_ClosePathEoillStroke = GetFunction(lib,"HPDF_Page_ClosePathEoillStroke")
    Global HPDF_Page_EndPath.HPDF_Page_EndPath = GetFunction(lib,"HPDF_Page_EndPath")
    Global HPDF_Page_BeginText.HPDF_Page_BeginText = GetFunction(lib,"HPDF_Page_BeginText")
    Global HPDF_Page_EndText.HPDF_Page_EndText = GetFunction(lib,"HPDF_Page_EndText")
    Global HPDF_Page_SetCharSpace.HPDF_Page_SetCharSpace = GetFunction(lib,"HPDF_Page_SetCharSpace")
    Global HPDF_Page_SetWordSpace.HPDF_Page_SetWordSpace = GetFunction(lib,"HPDF_Page_SetWordSpace")
    Global HPDF_Page_SetHorizontalScalling.HPDF_Page_SetHorizontalScalling = GetFunction(lib,"HPDF_Page_SetHorizontalScalling")
    Global HPDF_Page_SetTextLeading.HPDF_Page_SetTextLeading = GetFunction(lib,"HPDF_Page_SetTextLeading")
    Global HPDF_Page_SetFontAndSize.HPDF_Page_SetFontAndSize = GetFunction(lib,"HPDF_Page_SetFontAndSize")
    Global HPDF_Page_SetTextRenderingMode.HPDF_Page_SetTextRenderingMode = GetFunction(lib,"HPDF_Page_SetTextRenderingMode")
    Global HPDF_Page_MoveTextPos.HPDF_Page_MoveTextPos = GetFunction(lib,"HPDF_Page_MoveTextPos")
    Global HPDF_Page_MoveTextPos2.HPDF_Page_MoveTextPos2 = GetFunction(lib,"HPDF_Page_MoveTextPos2")
    Global HPDF_Page_MoveToNextLine.HPDF_Page_MoveToNextLine = GetFunction(lib,"HPDF_Page_MoveToNextLine")
    Global HPDF_Page_ShowText.HPDF_Page_ShowText = GetFunction(lib,"HPDF_Page_ShowText")
    Global HPDF_Page_ShowTextNextLine.HPDF_Page_ShowTextNextLine = GetFunction(lib,"HPDF_Page_ShowTextNextLine")
    Global HPDF_Page_ShowTextNextLineEx.HPDF_Page_ShowTextNextLineEx = GetFunction(lib,"HPDF_Page_ShowTextNextLineEx")
    Global HPDF_Page_SetGrayFill.HPDF_Page_SetGrayFill = GetFunction(lib,"HPDF_Page_SetGrayFill")
    Global HPDF_Page_SetGrayStroke.HPDF_Page_SetGrayStroke = GetFunction(lib,"HPDF_Page_SetGrayStroke")
    Global HPDF_Page_SetRGBFill.HPDF_Page_SetRGBFill = GetFunction(lib,"HPDF_Page_SetRGBFill")
    Global HPDF_Page_SetRGBStroke.HPDF_Page_SetRGBStroke = GetFunction(lib,"HPDF_Page_SetRGBStroke")
    Global HPDF_Page_SetCMYKFill.HPDF_Page_SetCMYKFill = GetFunction(lib,"HPDF_Page_SetCMYKFill")
    Global HPDF_Page_SetCMYKStroke.HPDF_Page_SetCMYKStroke = GetFunction(lib,"HPDF_Page_SetCMYKStroke")
    Global HPDF_Page_DrawImage.HPDF_Page_DrawImage = GetFunction(lib,"HPDF_Page_DrawImage")
    Global HPDF_Page_Circle.HPDF_Page_Circle = GetFunction(lib,"HPDF_Page_Circle")
    Global HPDF_Page_Arc.HPDF_Page_Arc = GetFunction(lib,"HPDF_Page_Arc")
    Global HPDF_Page_Ellipse.HPDF_Page_Ellipse = GetFunction(lib,"HPDF_Page_Ellipse")
    Global HPDF_Page_TextOut.HPDF_Page_TextOut = GetFunction(lib,"HPDF_Page_TextOut")
    Global HPDF_Page_TextRect.HPDF_Page_TextRect = GetFunction(lib,"HPDF_Page_TextRect")
    Global HPDF_Page_SetTextMatrix.HPDF_Page_SetTextMatrix = GetFunction(lib,"HPDF_Page_SetTextMatrix")
    ; Font    
    Global HPDF_Font_GetFontName.HPDF_Font_GetFontName = GetFunction(lib,"HPDF_Font_GetFontName")
    Global HPDF_Font_GetEncodingName.HPDF_Font_GetEncodingName = GetFunction(lib,"HPDF_Font_GetEncodingName")
    Global HPDF_Font_GetUnicodeWidth.HPDF_Font_GetUnicodeWidth = GetFunction(lib,"HPDF_Font_GetUnicodeWidth")
    Global HPDF_Font_GetBBox.HPDF_Font_GetBBox = GetFunction(lib,"HPDF_Font_GetBBox")
    Global HPDF_Font_GetAscent.HPDF_Font_GetAscent = GetFunction(lib,"HPDF_Font_GetAscent")
    Global HPDF_Font_GetDescent.HPDF_Font_GetDescent = GetFunction(lib,"HPDF_Font_GetDescent")
    Global HPDF_Font_GetXHeight.HPDF_Font_GetXHeight = GetFunction(lib,"HPDF_Font_GetXHeight")
    Global HPDF_Font_GetCapHeight.HPDF_Font_GetCapHeight = GetFunction(lib,"HPDF_Font_GetCapHeight")
    Global HPDF_Font_TextWidth.HPDF_Font_TextWidth = GetFunction(lib,"HPDF_Font_TextWidth")
    Global HPDF_Font_MeasureText.HPDF_Font_MeasureText = GetFunction(lib,"HPDF_Font_MeasureText")
    ; Encoder
    Global HPDF_Encoder_GetType.HPDF_Encoder_GetType = GetFunction(lib,"HPDF_Encoder_GetType")
    Global HPDF_Encoder_GetByteType.HPDF_Encoder_GetByteType = GetFunction(lib,"HPDF_Encoder_GetByteType")
    Global HPDF_Encoder_GetUnicode.HPDF_Encoder_GetUnicode = GetFunction(lib,"HPDF_Encoder_GetUnicode")
    Global HPDF_Encoder_GetWritingMode.HPDF_Encoder_GetWritingMode = GetFunction(lib,"HPDF_Encoder_GetWritingMode")
    ; Annotation
    Global HPDF_LinkAnnot_SetHighlightMode.HPDF_LinkAnnot_SetHighlightMode = GetFunction(lib,"HPDF_LinkAnnot_SetHighlightMode")
    Global HPDF_LinkAnnot_SetBorderStyle.HPDF_LinkAnnot_SetBorderStyle = GetFunction(lib,"HPDF_LinkAnnot_SetBorderStyle")
    Global HPDF_TextAnnot_SetIcon.HPDF_TextAnnot_SetIcon = GetFunction(lib,"HPDF_TextAnnot_SetIcon")
    Global HPDF_TextAnnot_SetOpened.HPDF_TextAnnot_SetOpened = GetFunction(lib,"HPDF_TextAnnot_SetOpened")
    ; Outline
    Global HPDF_Outline_SetOpened.HPDF_Outline_SetOpened = GetFunction(lib,"HPDF_Outline_SetOpened")
    Global HPDF_Outline_SetDestination.HPDF_Outline_SetDestination = GetFunction(lib,"HPDF_Outline_SetDestination")
    ; Destination
    Global HPDF_Destination_SetXYZ.HPDF_Destination_SetXYZ = GetFunction(lib,"HPDF_Destination_SetXYZ")
    Global HPDF_Destination_SetFit.HPDF_Destination_SetFit = GetFunction(lib,"HPDF_Destination_SetFit")
    Global HPDF_Destination_SetFitH.HPDF_Destination_SetFitH = GetFunction(lib,"HPDF_Destination_SetFitH")
    Global HPDF_Destination_SetFitV.HPDF_Destination_SetFitV = GetFunction(lib,"HPDF_Destination_SetFitV")
    Global HPDF_Destination_SetFitR.HPDF_Destination_SetFitR = GetFunction(lib,"HPDF_Destination_SetFitR")
    Global HPDF_Destination_SetFitB.HPDF_Destination_SetFitB = GetFunction(lib,"HPDF_Destination_SetFitB")
    Global HPDF_Destination_SetFitBH.HPDF_Destination_SetFitBH = GetFunction(lib,"HPDF_Destination_SetFitBH")
    Global HPDF_Destination_SetFitBV.HPDF_Destination_SetFitBV = GetFunction(lib,"HPDF_Destination_SetFitBV")
    ; Image
    Global HPDF_Image_GetSize.HPDF_Image_GetSize = GetFunction(lib,"HPDF_Image_GetSize")
    Global HPDF_Image_GetWidth.HPDF_Image_GetWidth = GetFunction(lib,"HPDF_Image_GetWidth")
    Global HPDF_Image_GetHeight.HPDF_Image_GetHeight = GetFunction(lib,"HPDF_Image_GetHeight")
    Global HPDF_Image_GetBitsPerComponent.HPDF_Image_GetBitsPerComponent = GetFunction(lib,"HPDF_Image_GetBitsPerComponent")
    Global HPDF_Image_GetColorSpace.HPDF_Image_GetColorSpace = GetFunction(lib,"HPDF_Image_GetColorSpace")
    Global HPDF_Image_SetColorMask.HPDF_Image_SetColorMask = GetFunction(lib,"HPDF_Image_SetColorMask")
    Global HPDF_Image_SetMaskImage.HPDF_Image_SetMaskImage = GetFunction(lib,"HPDF_Image_SetMaskImage")
    ; ExtGState
    Global HPDF_ExtGState_SetAlphaStroke.HPDF_ExtGState_SetAlphaStroke = GetFunction(lib,"HPDF_ExtGState_SetAlphaStroke")
    Global HPDF_ExtGState_SetAlphaFill.HPDF_ExtGState_SetAlphaFill = GetFunction(lib,"HPDF_ExtGState_SetAlphaFill")
    Global HPDF_ExtGState_SetBlendMode.HPDF_ExtGState_SetBlendMode = GetFunction(lib,"HPDF_ExtGState_SetBlendMode")
   EndIf
  ProcedureReturn Lib
EndProcedure

HaruPDF_Init()

; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 883
; FirstLine = 51
; Folding = AAAAAk
; DisableDebugger
; EnableCompileCount = 50
; EnableBuildCount = 0